//
// Final Project					-- Asteroids
//
// main.cpp: defines callbacks, initialization, and main entry point.
//
//
//      AUTHOR: Russell Lowke
//
//		  Date: Jan 19th 2005
//

#include "Asteroids.h"

#include <iostream>
#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glu.h>

using namespace std;

// global variables
Asteroids* g_asteroids;

// GLUT CALLBACKS
void on_display() {
	g_asteroids->on_display();
}
void on_window_reshape(int w, int h) {
	g_asteroids->on_window_reshape(w, h);
}
void on_keyboard(unsigned char key, int x, int y) {
	g_asteroids->on_keyboard(key, x, y);
}
void on_mouse(int button, int state, int x, int y) {
	g_asteroids->on_mouse(button, state, x, y);
}
void on_mouse_move (int x, int y) {
	g_asteroids->on_mouse_move(x, y);
}

void dieAfterReturn()
{
	cerr << "Press return to exit...";
	cin.sync();
	cin.get();
	exit( 0 );
}

//
// main 
//
// Main entry point for this program.
// initialize your GLUT window, 
// set up our callbacks, and enter the main event loop.
//
int main(int argc, char* argv[])
{

	const static int wWidth  = 800;
	const static int wHeight = 600;
	const static int wX      = 100;
	const static int wY      = 100;

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(wWidth, wHeight);
	glutInitWindowPosition(wX, wY);
	glutCreateWindow("Final Project - Asteroids");

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	// Tell GLUT about callback functions
	glutDisplayFunc		  (on_display);
    glutReshapeFunc		  (on_window_reshape);
	glutPassiveMotionFunc (on_mouse_move);
    glutKeyboardFunc	  (on_keyboard);
	glutMouseFunc		  (on_mouse);

	// create Asteroids game object
	g_asteroids = new Asteroids(wWidth, wHeight, wX, wY);

    glutMainLoop();		// enter glut main loop

	delete g_asteroids;

    return 0;

}